/* $RCSfile$ */
/* $Author$ */
/* $Date$ */
/* $Revision$ */

#include <sys/types.h>
#include "hdfi.h"
#include "cris.h"

#include "crisGetData/checkCompressedEvent.h"
#include "crisGetData/unpackCenterPhas_c.h"
#include "crisGetData/unpackEventHeader_c.h"
#include "crisGetData/unpackGuardPhas_c.h"
#include "crisGetData/unpackHodoscopeData_c.h"
#include "crisGetData/unpackStimData_c.h"
#include "crisGetData/unpackTagBits_c.h"


#define NMNF  NUM_CRIS_MNFS_PER_CYCLE

int unpackEventCycle_c(struct L1CrisEventCycle *EventCycle,
                             struct ce_crisEvt *event)
{
   struct ce_crisEvt *evt;

    uint8 *EventBuffer;
      int i;
   uint32 index;
   uint16 nevent;
      int nevt;

   nevent = EventCycle->NumberEvents;
   EventBuffer = EventCycle->EventBuffer;

   index = 0;
   nevt = 0;
   for (i=0; i<nevent; i++) {
      evt = event + i;
      if (checkCompressedEvent_c(EventBuffer, index+2, evt)) {
         index += (uint32) EventBuffer[index+2] + 2;
         continue;
      }
      evt->secs1996 = EventCycle->Second1996;
      evt->usec = EventCycle->microsecond;
      evt->rfu = 0L;
      evt->cam = 0x01;
      evt->evtno = EventCycle->ClockCycle + 
                   NMNF * ((uint32) EventBuffer[index]) +
                   (uint32) EventBuffer[index+1];
      index = index + 2;
      unpackEventHeader_c(EventBuffer, &index, evt);
      unpackHodoscopeData_c(EventBuffer, &index, evt);
      unpackTagBits_c(EventBuffer, &index, 1, evt);
      unpackCenterPhas_c(EventBuffer, &index, 1, evt);
      unpackGuardPhas_c(EventBuffer, &index, 1, evt);
      unpackTagBits_c(EventBuffer, &index, 2, evt);
      unpackCenterPhas_c(EventBuffer, &index, 2, evt);
      unpackGuardPhas_c(EventBuffer, &index, 2, evt);
      unpackStimData_c(EventBuffer, &index, evt);
      nevt++;
   }
   evt = event + nevt;
   evt->evtno = 0L;
   evt->secs1996 = 0L;
   evt->usec = 0L;

   return nevt;
}

#undef NMNF
