#include <stdio.h>
#include <string.h>
#include "hdfi.h"
#include "cris.h"
#include "sis.h"

uint32 getTimeStamp(void *pStruct, char *structName) {
    if (strstr(structName, "Cris") != NULL) {
        if (strcmp(structName, "BrowseCris") == 0)
            return (uint32) ((struct BrowseCris *) pStruct)->bin_start;
        else if (strcmp(structName, "L1CrisCommandEcho") == 0)
            return ((struct L1CrisCommandEcho *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisCommandTable") == 0) return
		((struct L1CrisCommandTable *) pStruct)->Second1996MinorFrame0;
        else if (strcmp(structName, "L1CrisDiagnosticEvent") == 0) return
	      ((struct L1CrisDiagnosticEvent *) pStruct)->Second1996MinorFrame0;
        else if (strcmp(structName, "L1CrisEventCycle") == 0)
            return ((struct L1CrisEventCycle *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisHighPriorityRate") == 0)
            return ((struct L1CrisHighPriorityRate *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisHskp") == 0)
            return ((struct L1CrisHskp *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisLowPriorityRate") == 0)
            return ((struct L1CrisLowPriorityRate *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisSubset") == 0)
            return ((struct L1CrisSubset *) pStruct)->Second1996;
        else if (strcmp(structName, "L1CrisSummary") == 0)
            return ((struct L1CrisSummary *) pStruct)->Second1996;
    }
    else {
        if (strcmp(structName, "BrowseSis") == 0)
            return (uint32) ((struct BrowseSis *) pStruct)->bin_start;
        else if (strcmp(structName, "L1SisCommandEcho") == 0)
            return ((struct L1SisCommandEcho *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisCommandTable") == 0) return
		((struct L1SisCommandTable *) pStruct)->Second1996MinorFrame0;
        else if (strcmp(structName, "L1SisDacOffset0") == 0)
            return ((struct L1SisDacOffset0 *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisDacOffset1") == 0)
            return ((struct L1SisDacOffset1 *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisDiagnosticEvent") == 0) return
	      ((struct L1SisDiagnosticEvent *) pStruct)->Second1996MinorFrame0;
        else if (strcmp(structName, "L1SisEventCycle") == 0)
            return ((struct L1SisEventCycle *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisHighPriorityRate") == 0)
            return ((struct L1SisHighPriorityRate *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisHskp") == 0)
            return ((struct L1SisHskp *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisLowPriorityRate") == 0)
            return ((struct L1SisLowPriorityRate *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisSubset") == 0)
            return ((struct L1SisSubset *) pStruct)->Second1996;
        else if (strcmp(structName, "L1SisSummary") == 0)
            return ((struct L1SisSummary *) pStruct)->Second1996;
    }
 
        /* if we got here, did not recognize the structure name */
    fprintf(stderr, "getStructSizeFromName: ERROR\n");
    fprintf(stderr, "  Struct name ->%s<- not recognized.  Exiting.\n\n",
                                                                structName);
    exit(0);
}
