#include <stdio.h>
#include <fcntl.h>
#include "hdfi.h"
#include "sis.h"
#include "crisSisGetUtilities.h"

/*

*/

int getSisEvents(struct L1SisEventCycle *pDataStruct) {
    unsigned int DATA_TYPE_ID = 0x00000230;
    char FILE_TYPE_SUFFIX[] = "evt";

	/* declared static so memory allocation occurs only once */
    static char dataBuffer[sizeof(struct L1SisEventCycle)];

	/* generalized for all sis data structures beyond this point */
	/*     (assumes all such structs have an identical Second1996 field) */

    int fd, intervalNumber, fileInitialized, status;
    char path[256];

	/* this returns a value to intervalNumber as well as path */
    determineDataFilePathAndCreateDirsAsNeeded(pDataStruct->Second1996,
				FILE_TYPE_SUFFIX, path, &intervalNumber, 'S');

    if ((fd = open(path, O_RDWR)) == -1) {
	fileInitialized = 0;
	fd = openOrCreateFileToReadWrite(path);
    }
    else fileInitialized = 1;

    if (!fileInitialized)
	createInitializedFile(fd, dataBuffer, sizeof(dataBuffer), DATA_TYPE_ID);

    status = writeDataStructToFile(fd, intervalNumber, dataBuffer,
				sizeof(dataBuffer), (char *) pDataStruct, path);
    close(fd);
    return status;
}
